#!/usr/bin/python3
# coding: utf-8
#
#   checkVtkModule.py
#
#       vtkのimportチェック
#
#   22/01/07    新規作成
#

import os, sys

import gettext
localeDir = os.getenv("TreeFoamPath") + "/data/locale"
gettext.install("treefoam", localeDir)

def isVtk(pgmName):
    isModule = False
    if "vtk" in sys.modules.keys():
        isModule = True
    else:
        try:
            import vtk
            isModule = True
        except:
            isModule = False
            import universalDialogs
            title = _("エラー")
            mess  = _("vtkがimportできない為、") + pgmName + _("が起動できません。\n")
            mess += _("  vtkをインストールしてください。")
            universalDialogs.errDialog(__name__, title, mess)
    return isModule

