#!/usr/bin/python3
#  coding: utf-8
#
#       getPyQtModule.py
#
#       PyQtのmoduleのimport状況を確認する。
#       確認結果が、PyQtModule変数に入る。
#
#   20/05/23    新規作成
#      06/11    バグ修正 (33行目 import PySide → import PySide2)
#

import sys

PyQtModule = None

QtModules = ["PyQt5", "PySide2", "PyQt4", "PySide"]

#既にimportされているか確認
for module in QtModules:
    if module in sys.modules.keys():
        PyQtModule = module
        break
    
#importされていない場合は、importできるものを探す。
if PyQtModule == None:
    #  PyQtを確認
    try:
        import PyQt5
        PyQtModule = "PyQt5"
    except ImportError:
        try:
            import PySide2
            PyQtModule = "PySide2"
        except ImportError:
            try:
                import PyQt4
                PyQtModule = "PyQt4"
            except ImportError:
                try:
                    import PySide
                    PyQtModule = "PySide"
                except:
                    raise ImportError("Cannot load either PyQt or PySide")
    print("import " + PyQtModule + "...")
